from flask import Flask, request , render_template, send_file, jsonify
##from flask_cors import CORS
import time
from datetime import datetime
from dotenv import load_dotenv
import requests
from bs4 import BeautifulSoup
import json
import ssl
import asyncio
from playwright.sync_api import Playwright, sync_playwright

app = Flask(__name__)

app.config['MAX_CONTENT_LENGTH'] = 2 * 1024 * 1024 * 1024

##CORS(app)  # 모든 도메인에 대해 CORS를 허용


## .env 로드
load_dotenv()


@app.route('/')
def index():
    return render_template('index.html')

@app.route('/community_bible_reading', methods = ['GET', 'POST'])
def community_bible_reading():



	try:

		with open ("schedule.json", "r") as f:
			data = json.load(f)

		##return data['data']

		##print('[2023년 하루 20분 공동체성경읽기] ' + data['data'][0]['month'].replace('월', '') + '/' + str(data['data'][0]['day']))


		##title, link = search_youtube('[2023년 하루 20분 공동체성경읽기] ' + data['data'][0]['month'].replace('월', '') + '/' + str(data['data'][0]['day']) + ' ' + data['data'][0]['books'][0])


		result = []

		loop_count = 1

		for element in data['data']:

			title = ''
			link = ''

			if 'title' in element and 'link' in element and element['title'] != '' and element['link'] != '':
				title = element['title']
				link = element['link']
			else:
				title, link = search_youtube('[2023년 하루 20분 공동체성경읽기] ' + element['month'].replace('월', '') + '/' + str(element['day']) + ' ' + element['books'][0][:2])


			result.append({'index' : loop_count
							, 'month' : element['month']
							, 'day' : element['day']
							, 'books' : element['books']
							, 'title' : title
							, 'link' : link
							})

			loop_count += 1

			# # if loop_count >= 3:
			# # 	break
			

		result = {'data' : result}

		# JSON 파일로 저장합니다.
		with open('schedule.json', 'w', encoding='utf-8') as f:
			json.dump(result, f, ensure_ascii=False, indent=4)		

		return jsonify(result)

	except Exception as error:

		error_file = 'rss_etnews.py'

		message = 'error : {}'.format(type(error).__name__)
		message += '\r\n\r\n' + 'message : ' + str(error)
		_, _ , tb = sys.exc_info()
		print('error file : ' + error_file)
		print('error line No : {}'.format(tb.tb_lineno))

		print(message)


		result = []

		result.append({'index' : 0
						, 'month' : '0'
						, 'day' : '0'
						, 'books' : message
						, 'title' : '에러'
						, 'link' : ''
						})

		result = {'data' : result}

		return jsonify(result)



def search_youtube(query):

	##query = '[2023년 하루 20분 공동체성경읽기] 1/1 창세기'

	search_query = query.replace(' ', '+')
	url = f'https://www.youtube.com/results?search_query={search_query}'

	
	title_element = ''

	with sync_playwright() as playwright:
		browser = playwright.chromium.launch(headless=False)
		page = browser.new_page()

		page.goto(url)

		##title_elements = page.query_selector_all('xpath=.//*[@id="video-title"]')

		title_elements = page.query_selector_all('a#video-title')

		# # print('---------------')
		# # print(str(title_elements))
		# # print('---------------')

		print('---------------')
		print('::' + query + '::')

		title = ''
		link = ''

		for title_element in title_elements:

			if title_element.inner_text() != title_element.inner_text().replace(query, ''):
				print('---------------')
				print(title_element.inner_text())
				print('---------------')

				link = title_element.get_attribute('href').split('&')[0]

				##title_array.append(title_element.inner_text() + ' / ' + f'https://www.youtube.com{link}')
				title = title_element.inner_text()
				link = f'https://www.youtube.com{link}'

				break

		##time.sleep(1)

		browser.close()
	
	return title, link




if __name__ == "__main__":
	ssl_context = ssl.SSLContext(ssl.PROTOCOL_TLS)
	ssl_context.load_cert_chain(certfile='/etc/letsencrypt/live/hesedon.com-0001/fullchain.pem', keyfile='/etc/letsencrypt/live/hesedon.com-0001/privkey.pem', password='secret')

	app.jinja_env.auto_reload = True
	app.config['TEMPLATES_AUTO_RELOAD'] = True

	app.run(host="0.0.0.0", port=6365, ssl_context=ssl_context, debug=True)
